//+------------------------------------------------------------------+
//|                              Jim Sloman's natural moving average |
//|                                                      ocn nma.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  DodgerBlue
#property indicator_color2  Red
#property indicator_color3  Aqua
#property indicator_color4  Magenta

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    Fast.NMAPeriod  = 20;
extern int    Fast.NMAPrice   = PRICE_CLOSE;
extern int    Fast.TEMAPeriod = 1;
extern int    Fast.Shift      = 0;
extern int    Slow.NMAPeriod  = 40;
extern int    Slow.NMAPrice   = PRICE_CLOSE;
extern int    Slow.TEMAPeriod = 1;
extern int    Slow.Shift      = 0;
extern int    RSIPeriod       = 8;
extern bool   ShowNmaLines    = true;

extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern bool   alertsNotify    = false;
extern string soundfile       = "alert2.wav";

extern int    arrowthickness  = 1;
extern double arrowsUpperGap  = 1.0;
extern double arrowsLowerGap  = 1.0;
extern int    linethickness   = 2;


//
//
//
//
//

double fnma[];
double snma[];
double CrossUp[];
double CrossDn[];
double rsi[];
double trend[];

double Fast.alpha;
double Slow.alpha;
int    timeFrame;
bool   calculateValue;
bool   returnBars;
string indicatorFileName;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,CrossUp);  SetIndexStyle(0,DRAW_ARROW,0,arrowthickness); SetIndexArrow(0,233);
   SetIndexBuffer(1,CrossDn ); SetIndexStyle(1,DRAW_ARROW,0,arrowthickness); SetIndexArrow(1,234);
   SetIndexBuffer(2,fnma);
   SetIndexBuffer(3,snma);
   SetIndexBuffer(4,rsi);
   SetIndexBuffer(5,trend);
   
   if (ShowNmaLines)
   {
     SetIndexStyle(2,DRAW_LINE,0,linethickness); 
     SetIndexStyle(3,DRAW_LINE,0,linethickness); 
   }
   else
   {
     SetIndexStyle(2,DRAW_NONE);
     SetIndexStyle(3,DRAW_NONE);
   }       
   
      Fast.TEMAPeriod = MathMax(Fast.TEMAPeriod,1);
      Fast.NMAPeriod  = MathMax(Fast.NMAPeriod ,1);
      Fast.alpha      = 2.0 /(1.0  + Fast.TEMAPeriod);
      Slow.TEMAPeriod = MathMax(Slow.TEMAPeriod,1);
      Slow.NMAPeriod  = MathMax(Slow.NMAPeriod ,1);
      Slow.alpha      = 2.0 /(1.0  + Slow.TEMAPeriod);

         //
         //
         //
         //
         //
                  
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="CalculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
         
         //
         //
         //
         //
         //

   SetIndexShift(2,Fast.Shift*timeFrame/Period());
   SetIndexShift(3,Slow.Shift*timeFrame/Period());
   IndicatorShortName (timeFrameToString(timeFrame)+" NMA");
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double tBuffer[][8];
#define iPrc 6
#define iMom 7

//
//
//
//
//

int start()
{
   int    counted_bars=IndicatorCounted();
   int    i,k,r,limit;
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { CrossUp[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
        
   if (calculateValue || timeFrame==Period())
   {
      if (ArrayRange(tBuffer,0) != Bars) ArrayResize(tBuffer,Bars);
      for(i=limit, r=Bars-i-1; i >= 0; i--,r++)
      {
         double Fast.rawPrice = iMA(NULL,0,1,0,MODE_SMA,Fast.NMAPrice,i);
      
         tBuffer[r][iPrc] = iTema(Fast.rawPrice,Fast.alpha,0,r);
         tBuffer[r][iMom] = tBuffer[r][iPrc]-tBuffer[r-1][iPrc];
   
         //
         //
         //
         //
         //
                      
            double Fast.momRatio = 0.00;
            double Fast.sumMomen = 0.00;
            double Fast.ratio    = 0.00;
      
            for (k = 0; k<Fast.NMAPeriod; k++)
            {
               Fast.sumMomen += MathAbs(tBuffer[r-k][iMom]);
               Fast.momRatio +=         tBuffer[r-k][iMom]*(MathSqrt(k+1)-MathSqrt(k));
            }
            if (Fast.sumMomen != 0) Fast.ratio = MathAbs(Fast.momRatio)/Fast.sumMomen;
      
         //
         //
         //
         //
         //
                 
         fnma[i] = fnma[i+1]+Fast.ratio*(Fast.rawPrice-fnma[i+1]);
         
         //
         //
         //
         //
         //
         
         double Slow.rawPrice = iMA(NULL,0,1,0,MODE_SMA,Slow.NMAPrice,i);
         tBuffer[r][iPrc]     = iTema(Slow.rawPrice,Slow.alpha,3,r);
         tBuffer[r][iMom]     = tBuffer[r][iPrc]-tBuffer[r-1][iPrc];
   
         //
         //
         //
         //
         //
                      
            double Slow.momRatio = 0.00;
            double Slow.sumMomen = 0.00;
            double Slow.ratio    = 0.00;
      
            for (k = 0; k<Slow.NMAPeriod; k++)
            {
               Slow.sumMomen += MathAbs(tBuffer[r-k][iMom]);
               Slow.momRatio +=         tBuffer[r-k][iMom]*(MathSqrt(k+1)-MathSqrt(k));
            }
            if (Slow.sumMomen != 0) Slow.ratio = MathAbs(Slow.momRatio)/Slow.sumMomen;
      
         //
         //
         //
         //
         //
                 
         snma[i] = snma[i+1]+Slow.ratio*(Slow.rawPrice-snma[i+1]);
      }
      
      for (i=limit; i>=0; i--)
      {
         trend[i] = trend[i+1];
           rsi[i] = iRSI(NULL,0,RSIPeriod,PRICE_CLOSE,i);
           if (fnma[i]>snma[i] && rsi[i]>50) trend[i] = 1;
           if (fnma[i]<snma[i] && rsi[i]<50) trend[i] =-1;

           //
           //
           //
           //
           //
      
          CrossUp[i] = EMPTY_VALUE;
          CrossDn[i] = EMPTY_VALUE;
          if (trend[i]!= trend[i+1])
          if (trend[i] == 1)
                CrossUp[i] =  Low[i] - arrowsLowerGap * iATR(NULL,0,20,i);
          else  CrossDn[i] = High[i] + arrowsUpperGap * iATR(NULL,0,20,i);
         }
         
      manageAlerts();
      return(0);
      }
   
      //
      //
      //
      //
      //
   
      limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
      for (i=limit;i>=0;i--)
      {
         int y = iBarShift(NULL,timeFrame,Time[i]);
            fnma[i]  = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",Fast.NMAPeriod,Fast.NMAPrice,Fast.TEMAPeriod,Fast.Shift,Slow.NMAPeriod,Slow.NMAPrice,Slow.TEMAPeriod,Slow.Shift,RSIPeriod,2,y);
            snma[i]  = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",Fast.NMAPeriod,Fast.NMAPrice,Fast.TEMAPeriod,Fast.Shift,Slow.NMAPeriod,Slow.NMAPrice,Slow.TEMAPeriod,Slow.Shift,RSIPeriod,3,y);
            rsi[i]   = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",Fast.NMAPeriod,Fast.NMAPrice,Fast.TEMAPeriod,Fast.Shift,Slow.NMAPeriod,Slow.NMAPrice,Slow.TEMAPeriod,Slow.Shift,RSIPeriod,4,y);
            trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",Fast.NMAPeriod,Fast.NMAPrice,Fast.TEMAPeriod,Fast.Shift,Slow.NMAPeriod,Slow.NMAPrice,Slow.TEMAPeriod,Slow.Shift,RSIPeriod,5,y);
            CrossUp[i] = EMPTY_VALUE;
            CrossDn[i] = EMPTY_VALUE;
            if (trend[i]!= trend[i+1])
            if (trend[i] == 1)
                  CrossUp[i] =  Low[i] - arrowsLowerGap * iATR(NULL,0,20,i);
            else  CrossDn[i] = High[i] + arrowsUpperGap * iATR(NULL,0,20,i); 
     }
     manageAlerts();
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double iTema(double price,double alpha,int sbuf,int i)
{
   if (i < 1)
      {
         tBuffer[i][sbuf+0] = price;
         tBuffer[i][sbuf+1] = price;
         tBuffer[i][sbuf+2] = price;
      }
   else
      {
         tBuffer[i][sbuf+0] = tBuffer[i-1][sbuf+0]+alpha*(price             -tBuffer[i-1][sbuf+0]);
         tBuffer[i][sbuf+1] = tBuffer[i-1][sbuf+1]+alpha*(tBuffer[i][sbuf+0]-tBuffer[i-1][sbuf+1]);
         tBuffer[i][sbuf+2] = tBuffer[i-1][sbuf+2]+alpha*(tBuffer[i][sbuf+1]-tBuffer[i-1][sbuf+2]);
      }
   return(3.0*tBuffer[i][sbuf+0] - 3.0*tBuffer[i][sbuf+1] + tBuffer[i][sbuf+2]);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"buy");
         if (trend[whichBar] ==-1) doAlert(whichBar,"sell");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" Nma+Rsi Cross ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Nma+Rsi Cross "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}